SystemOrganization addCategory: #'Tweak-EToys'!
SystemOrganization addCategory: #'Tweak-EToys-Experimental'!

CPanel subclass: #EToysCostumesTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys-Experimental'!

!EToysCostumesTool commentStamp: '<historical>' prior: 0!
For a given player I show a list of its costumes!

EToysCostumesTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="list" toSet="list:" changeEvent="listChanged">list</field>
</fields>'!

!EToysCostumesTool methodsFor: 'initialize' stamp: 'ar 6/20/2005 16:22'!
initialize
	super initialize.
	label := 'Costumes'.
	list := CList new.
	list itemMaker: EToysIcon.! !

!EToysCostumesTool methodsFor: 'accessing' stamp: 'ar 6/20/2005 16:19'!
list
	"Answer the list of the receiver"
	<bewareOf: #listChanged>
	^self propertyValueAt: #list! !

!EToysCostumesTool methodsFor: 'accessing' stamp: 'ar 6/20/2005 16:19'!
list: aValue
	"Modify the receiver's list"
	^self propertyValueAt: #list put: aValue with: #listChanged! !

!EToysCostumesTool methodsFor: 'events' stamp: 'ar 6/20/2005 16:38'!
onCostumesToolRequest: aPlayer
	<on: costumesToolRequest in: world>
	aPlayer == target ifFalse:[^self].
	aPlayer signal: #costumesToolFound with: self.
	self comeToFront.
	self flash.
	self restore.
	self beOnScreen.! !

!EToysCostumesTool methodsFor: 'events' stamp: 'ar 6/20/2005 21:42'!
onDragDrop: aPlayer
	"Add the player as a new costume to the animation"
	<on: dragDrop>
	aPlayer == target ifTrue:[^aPlayer signal: #dropReject].
	aPlayer close.
	target eToyCostumes addAll: aPlayer eToyCostumes.
	self makeSound: 'scritch'.! !

!EToysCostumesTool methodsFor: 'events' stamp: 'ar 6/20/2005 16:28'!
onNameChanged
	<on: nameChanged in: target>
	label := target name,'''s costumes'.! !

!EToysCostumesTool methodsFor: 'events' stamp: 'ar 6/20/2005 21:42'!
onTargetChanged
	<on: targetChanged>
	target ifNil:[^self].
	list items: target eToyCostumes.
	self onNameChanged.! !

!EToysCostumesTool methodsFor: 'initialize' stamp: 'ar 6/20/2005 20:57'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	list allowDeselect: false.
	list layout listDirection: #leftToRight.
	list layout wrapDirection: #topToBottom.
	list layout layoutInset: 4.
	list layout cellInset: 4.
	self addLast: list.
	self extent :=  275@230.
	self decorate: costume elements color: self defaultWindowColor.! !

!EToysCostumesTool methodsFor: 'accessing' stamp: 'ar 6/20/2005 16:23'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!EToysCostumesTool methodsFor: 'accessing' stamp: 'ar 6/20/2005 16:23'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #CMagnifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

!CMagnifier commentStamp: '<historical>' prior: 0!
CMagnifierPlayer instances are magnifying lenses that magnify the player below them (if grabbed or if trackPointer is false) or the area around the mouse pointer.
Each parameter is controlled by a slot in viewer.

Instance variables:

magnification	<Number> The magnification to use. If non-integer, smooths the magnified form.

sourcePlayer	<CPlayer> indicates the position of the source area.

trackPointer		<Boolean> If set, magnifies the area around the Hand. If not, magnfies the area underneath the magnifier center.

showPointer		<Boolean> If set, display a small reversed rectangle in the center of the lens. Also enables the display of Morphs in the Hand itself.

CMagnifierPlayer new openInHand!

CMagnifier defineFields: '<?xml  version="1.0" ?>
<fields>
	<field virtual="true" serializable="false" toGet="trackPointer" toSet="trackPointer:">trackPointer</field>
	<field toGet="showPointer" toSet="showPointer:" changeEvent="showPointerChanged">showPointer</field>
	<field toGet="sourcePlayer" toSet="sourcePlayer:" changeEvent="sourcePlayerChanged">sourcePlayer</field>
</fields>'!

!CMagnifier class methodsFor: 'class initialization' stamp: 'tak 5/2/2005 16:22'!
initialize
	"self initialize"
	self registerWithPartsBin.
! !

!CMagnifier class methodsFor: 'instance creation' stamp: 'tak 5/9/2005 17:01'!
newRound
	"CMagnifierPlayer newRound openInHand"
	| aMagnifier costume screen |
	aMagnifier := self new.
	costume := CScreeningCostume new.
	screen := CEllipsePlayer new.
	screen bounds := aMagnifier bounds.
	screen color := Color gray.
	aMagnifier costume: costume.
	costume screen: screen.
	aMagnifier setupCostume.
	aMagnifier name: 'Round glass'.
	^ aMagnifier! !

!CMagnifier class methodsFor: 'class initialization' stamp: 'tak 5/9/2005 14:06'!
newbornPartToDropIn: player
	^ super newbornPartToDropIn: player! !

!CMagnifier class methodsFor: 'class initialization' stamp: 'tak 5/10/2005 15:57'!
registerWithPartsBin
	"Register the receiver in the basic category"
	CPartsBin
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'Magnifier'
				balloonHelp: 'A magnifying glass'
				category: 'miscellaneous'
				creator: self
				selector: #newbornPartToDropIn:
				customForm: nil).
	CPartsBin
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'RoundGlass'
				balloonHelp: 'A round magnifying glass'
				category: 'miscellaneous'
				creator: self
				selector: #newRound
				customForm: nil)! !

!CMagnifier class methodsFor: 'class initialization' stamp: 'sw 6/17/2005 01:03'!
registerWithPartsSource: aPartsSource
	"Register the receiver in the miscellaneous category of the partsSource provided."

	aPartsSource
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'Magnifier'
				balloonHelp: 'A magnifying glass'
				category: 'miscellaneous'
				creator: self
				selector: #newbornPartToDropIn:
				customForm: nil).
	aPartsSource
		registerPartDescription: (CPartDescription
				partDescriptionWithLabel: 'RoundGlass'
				balloonHelp: 'A round magnifying glass'
				category: 'miscellaneous'
				creator: self
				selector: #newRound
				customForm: nil)! !

!CMagnifier methodsFor: 'initialize' stamp: 'tak 5/9/2005 15:57'!
initialize
	super initialize
	showPointer := false.
! !

!CMagnifier methodsFor: 'initialize' stamp: 'tak 5/9/2005 16:08'!
setupCostume
	super setupCostume.
	self graphicEnabled: true.
	self scale := 2.
	self color := Color transparent.
	self extent := 128 @ 128.
	self graphicFit := #rigid.

	self borderWidth := 1.
	self borderColor := Color black.
	self borderStyle := #simple.

	sourcePlayer := self hand.
! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 4/30/2005 20:05'!
showPointer
	"Answer the showPointer of the receiver"
	<bewareOf: #showPointerChanged>
	^self propertyValueAt: #showPointer! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 4/30/2005 20:05'!
showPointer: aValue
	"Modify the receiver's showPointer"
	^self propertyValueAt: #showPointer put: aValue with: #showPointerChanged! !

!CMagnifier methodsFor: 'magnifying' stamp: 'ar 6/1/2005 20:50'!
sourceForm
	"Answer the source form"
	| srcRect srcForm |
	srcRect := self sourceRectFrom: sourcePlayer center.
	srcForm := self world asPrimCostume
						patchAt: srcRect
						without: self
						andNothingAbove: false.
	showPointer
		ifTrue: [srcForm
				reverse: (srcForm center - (1 @ 1) extent: 2 @ 2)
				fillColor: Color white].
	^ srcForm! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 5/5/2005 17:08'!
sourcePlayer
	"Answer the sourcePlayer of the receiver"
	<bewareOf: #sourcePlayerChanged>
	^self propertyValueAt: #sourcePlayer! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 5/5/2005 17:08'!
sourcePlayer: aValue
	"Modify the receiver's sourcePlayer"
	^self propertyValueAt: #sourcePlayer put: aValue with: #sourcePlayerChanged! !

!CMagnifier methodsFor: 'magnifying' stamp: 'tak 5/9/2005 16:06'!
sourceRectFrom: aPoint 
	| srcExtent |
	srcExtent := self localBounds extent - (2 * borderWidth).
	^ (aPoint extent: srcExtent)
		translateBy: srcExtent // -2! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 5/5/2005 17:38'!
trackPointer
	"Answer the trackPointer of the receiver"
	^ sourcePlayer = self hand! !

!CMagnifier methodsFor: 'accessing' stamp: 'tak 5/9/2005 15:55'!
trackPointer: aValue
	"It provides same protocol of MagnifierMorph"
	aValue
		ifTrue: [sourcePlayer := self hand]
		ifFalse: [sourcePlayer := self]
! !

!CMagnifier methodsFor: 'updating' stamp: 'ar 6/1/2005 20:50'!
updateGraphics
	self world ifNotNil: [self graphic: self sourceForm]! !

!CMagnifier methodsFor: 'updating' stamp: 'tak 5/5/2005 17:42'!
updatePosition
	<on: frameChanged in: sourcePlayer>
	self updateGraphics! !

!CMagnifier methodsFor: 'updating' stamp: 'tak 5/9/2005 09:16'!
updateTick
	<ticking: 10>
	self updateGraphics.
	self invalidate! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'ar 6/23/2005 14:36'!
assurePen
	"Make sure my pen has been created"
	^costume assurePen! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 4/27/2005 11:40'!
brightnessUnder
	"Answer the brightness under the receiver's position"
	^self colorUnder brightness * 100! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/28/2005 15:57'!
clearPenTrails
	"Look up the container hierarchy to find a Player who has penTrails.  Erase the Form that has the marks."
	costume clearPenTrails! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 6/25/2005 14:58'!
color: myColor sees: otherColor 
	"Return true if any of my pixels of sensitiveColor intersect with pixels of soughtColor."
	"Make a mask with black where sensitiveColor is, white elsewhere"
	| myImage map i1 myWorld myBox canvas sensitiveMask patch |
	myWorld := self world ifNil: [^false].
	myBox := self globalBounds.
	myImage := Form extent: myBox extent depth: Display depth.
	canvas := CTransformCanvas on: myImage.
	canvas translateBy: myBox origin negated.
	"Note: Cannot use #fullDrawOn: here since this only transforms to parent"
	canvas transformBy: self localToGlobal clippingTo: self asPrimCostume drawingBounds
		during:[:cc| self asPrimCostume localFullDrawOn: cc].
	sensitiveMask := Form extent: myImage extent depth: 1.
	"ensure at most a 16-bit map"
	map := Bitmap new: (1 bitShift: (myImage depth - 1 min: 15)).
	map at: (i1 := myColor indexInMap: map) put: 1.
	sensitiveMask copyBits: sensitiveMask boundingBox from: myImage at: 0 @ 0 colorMap: map.

	"get an image of the world below me"
	patch := myWorld asPrimCostume patchAt: myBox without: self andNothingAbove: true.

	"intersect world pixels of the color we're looking for with the sensitive pixels"
	map at: i1 put: 0.	"clear map and reuse it"
	map at: (otherColor indexInMap: map) put: 1.
	sensitiveMask copyBits: patch boundingBox from: patch at: 0 @ 0
		clippingBox: patch boundingBox rule: Form and fillColor: nil map: map.
	^(sensitiveMask tallyPixelValues at: 2) > 0! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 4/27/2005 11:40'!
colorUnder
	"Answer the color under the receiver's position"
	| myWorld pt |
	myWorld := self world ifNil:[^Color black].
	pt := self globalPosition.
	"NOTE: due to some bounds wobble in flexing, we take the middle of 3x3 rect."
	^ (myWorld asPrimCostume patchAt: (pt-1 extent: 3) without: self andNothingAbove: true)
		colorAt: 1@1! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 6/20/2005 21:43'!
eToyCostumes
	^Array with: self! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 6/26/2005 17:55'!
forwardBy: delta duration: seconds
	| dt lastTime nextTime amount remain |
	seconds <= 0 ifTrue:[^self forwardBy: delta].
	dt := delta / (seconds * 1000.0).
	remain := delta.
	lastTime := Time millisecondClockValue.
	[remain > 0.0] whileTrue:[
		self waitTick.
		nextTime := Time millisecondClockValue.
		amount := ((nextTime - lastTime max: 0) * dt) min: remain.
		self forwardBy: amount.
		remain := remain - amount.
		lastTime := nextTime.
	].
! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/25/2005 13:55'!
indicatePenTrails
	"Tell whether I record the pen trails left by my elements and their elements appear inside me."

	^ costume indicatePenTrails! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/26/2005 16:54'!
indicatePenTrails: aBoolean
	"Only use this if you want this object to be the floor where turtles can draw.  true makes the trails left by my elements and their elements appear inside me.  Any object can act like a turtle."

	costume indicatePenTrails: aBoolean! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 4/27/2005 11:40'!
luminanceUnder
	"Answer the brightness under the receiver's position"
	^self colorUnder luminance * 100! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/27/2005 13:28'!
pen
	"Answer the pen of the receiver"
	<bewareOf: #penChanged>
	^costume pen! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/27/2005 13:28'!
pen: aValue
	"A pen is an object that can draw a line in the nearest enclosing container that allows pen trails.  Any Player in Tweak can lay down a line as it moves.  The line is usually drawn in the World's pen trails.  A pen has a penWidth, a penColor, is up or down, and a penTrailStyle.  The default pen is up and does not draw a line.  Styles are plain lines, arrows (lines with an arrowHead at the end of each movement), arrowHeads (just arrowheads and not the lines), and dots."
	^ costume pen: aValue! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/28/2005 15:47'!
penColor
	"penColor is the color that the pen draws when the object moves."
	<bewareOf: #penChanged>
	^(self pen ifNil: [^ CCostumePen defaultColor]) color! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'ar 6/23/2005 14:52'!
penColor: aColor
	"penColor is the color that the pen draws when the object moves.  The pen must be down, or no mark will be made."
	self flag: #fixMe.
	"Note: Copying below is done so that we do not share the 'cachedBitPattern' in the color - since the costume keeps a BitBlt around (FIX THIS) it will create a shared reference if the color is one of the named colors."
	^ costume assurePen color: (Color r: aColor red g: aColor green b: aColor blue alpha: aColor alpha)! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/28/2005 15:46'!
penDown
	"penDown is true when the pen is able to draw, and false when it does not draw."
	<bewareOf: #penChanged>
	^(self pen ifNil: [^false]) isDown
! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/27/2005 13:34'!
penDown: aValue
	"penDown is true when the pen is able to draw, and false when it does not draw."
	^ costume assurePen isDown: aValue! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/28/2005 15:47'!
penTrailStyle
	"penTrailStyle determines how the line will look.  The styles are plain lines, arrows (lines with an arrowHead at the end of each movement), arrowHeads (just arrowheads and not the lines), and dots."
	<bewareOf: #penChanged>
	^(self pen ifNil: [^#lines]) penTrailStyle! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/27/2005 13:36'!
penTrailStyle: aValue
	"penTrailStyle determines how the line will look.  The styles are plain lines, arrows (lines with an arrowHead at the end of each movement), arrowheads (just arrowheads and not the lines), and dots."
	^ costume assurePen penTrailStyle: aValue! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/28/2005 15:47'!
penWidth
	"penWidth is the width of the line that a pen draws.  It is a number of screen dots."
	<bewareOf: #penChanged>
	^(self pen ifNil: [^ CCostumePen defaultWidth]) width! !

!CPlayer methodsFor: '*Tweak-EToys-Pen' stamp: 'tk 4/27/2005 13:36'!
penWidth: aValue
	"penWidth is the width of the line that a pen draws.  It is a number of screen dots."
	^ costume assurePen width: aValue! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 4/27/2005 11:42'!
saturationUnder
	"Answer the brightness under the receiver's position"
	^self colorUnder saturation * 100! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 6/25/2005 14:58'!
touchesColor: soughtColor
	"Return true if any of my pixels of sensitiveColor intersect with pixels of soughtColor."
	"Make a mask with black where sensitiveColor is, white elsewhere"
	| myImage map myWorld myBox canvas sensitiveMask patch |
	myWorld := self world ifNil: [^false].
	myBox := self globalBounds.
	myImage := Form extent: myBox extent depth: Display depth.
	canvas := CTransformCanvas on: myImage.
	canvas translateBy: myBox origin negated.
	"Note: Cannot use #fullDrawOn: here since this only transforms to parent"
	canvas transformBy: self localToGlobal clippingTo: self asPrimCostume drawingBounds
		during:[:cc| self asPrimCostume localFullDrawOn: cc].
	sensitiveMask := Form extent: myImage extent depth: 1.
	"ensure at most a 16-bit map"
	map := Bitmap new: (1 bitShift: (myImage depth - 1 min: 15)).
	"@@@@ FIXME: Would be easier to map transparent (index=0) and reverse combination rule below."
	map atAllPut: 1.
	map at: 1 put: 0.
	sensitiveMask copyBits: sensitiveMask boundingBox from: myImage at: 0 @ 0 colorMap: map.

	"get an image of the world below me"
	patch := myWorld asPrimCostume patchAt: myBox without: self andNothingAbove: false.

	"intersect world pixels of the color we're looking for with the sensitive pixels"
	map atAllPut: 0.	"clear map and reuse it"
	map at: (soughtColor indexInMap: map) put: 1.
	sensitiveMask copyBits: patch boundingBox from: patch at: 0 @ 0
		clippingBox: patch boundingBox rule: Form and fillColor: nil map: map.
	^(sensitiveMask tallyPixelValues at: 2) > 0! !

!CPlayer methodsFor: '*Tweak-EToys' stamp: 'ar 6/26/2005 17:56'!
turnBy: delta duration: seconds
	| dt lastTime nextTime amount remain |
	seconds <= 0 ifTrue:[^self turnBy: delta].
	dt := delta / (seconds * 1000.0).
	remain := delta.
	lastTime := Time millisecondClockValue.
	[remain > 0.0] whileTrue:[
		self waitTick.
		nextTime := Time millisecondClockValue.
		amount := ((nextTime - lastTime max: 0) * dt) min: remain.
		self turnBy: amount.
		remain := remain - amount.
		lastTime := nextTime.
	].
! !

CPlayer subclass: #CScreeningCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

!CScreeningCostume commentStamp: '<historical>' prior: 0!
I am a costume like ScreeningMorph. screen is used as 1-bit mask, the passing color is decided from the center pixel of screen.

Structure:
	screen		CPlayer -- a player used as mask.
	passingColor Color -- a passing color of screen player.!

CScreeningCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="screen" toSet="screen:" changeEvent="screenChanged">screen</field>
	<field toGet="passingColor" toSet="passingColor:" changeEvent="passingColorChanged">passingColor</field>
</fields>'!

!CScreeningCostume class methodsFor: 'examples' stamp: 'tak 5/6/2005 14:59'!
example1
	"self example1"
	| player |
	player := CTrashCan new.
	player costume: self new.
	player costume screen: (CPolygonPlayer new color: Color gray; yourself).
	player openInHand.! !

!CScreeningCostume class methodsFor: 'examples' stamp: 'tak 5/6/2005 15:24'!
example2
	"self example2"
	| player |
	player := CTrashCan new.
	player costume: self new.
	player costume screen: (CEllipsePlayer new color: Color gray; yourself).
	player costume costume: self new.
	player costume costume screen: (CPolygonPlayer new color: Color gray; borderWidth: 0; yourself).
	player openInHand.! !

!CScreeningCostume methodsFor: 'drawing' stamp: 'tak 5/6/2005 11:35'!
drawOn: aCanvas in: drawingBounds 
	screen drawOn: aCanvas in: drawingBounds.
	aCanvas
		paintImage: (self mergeWith: self sourceForm)
		at: drawingBounds origin! !

!CScreeningCostume methodsFor: 'initialize' stamp: 'tak 5/6/2005 14:15'!
initialize
	super initialize.
	self userDraw := true.
	screen := CEllipsePlayer new color: Color gray; yourself.
! !

!CScreeningCostume methodsFor: 'accessing' stamp: 'tak 5/6/2005 10:02'!
mergeWith: aForm 
	| mergeForm |
	mergeForm := aForm copy.
	(BitBlt current toForm: mergeForm)
		copyForm: self screenForm
		to: 0 @ 0
		rule: Form and
		colorMap: (Bitmap with: 0 with: 4294967295).
	^ mergeForm! !

!CScreeningCostume methodsFor: 'events' stamp: 'tak 5/6/2005 15:19'!
onBorderChanged
	<on: borderChanged>
	screen border := border copy! !

!CScreeningCostume methodsFor: 'events' stamp: 'tak 5/6/2005 12:03'!
onExtentChanged
	<on: extentChanged>
	screen extent := extent! !

!CScreeningCostume methodsFor: 'accessing' stamp: 'tak 5/5/2005 20:22'!
passingColor
	"Answer the passingColor of the receiver"
	<bewareOf: #passingColorChanged>
	^self propertyValueAt: #passingColor! !

!CScreeningCostume methodsFor: 'accessing' stamp: 'tak 5/5/2005 20:22'!
passingColor: aValue
	"Modify the receiver's passingColor"
	^self propertyValueAt: #passingColor put: aValue with: #passingColorChanged! !

!CScreeningCostume methodsFor: 'accessing' stamp: 'tak 5/5/2005 20:22'!
screen
	"Answer the screen of the receiver"
	<bewareOf: #screenChanged>
	^self propertyValueAt: #screen! !

!CScreeningCostume methodsFor: 'accessing' stamp: 'tak 5/6/2005 15:19'!
screen: aValue
	"Modify the receiver's screen"
	passingColor := aValue asForm colorAt: aValue center.
	self border := aValue border copy.
	^self propertyValueAt: #screen put: aValue with: #screenChanged! !

!CScreeningCostume methodsFor: 'drawing' stamp: 'tak 5/6/2005 07:52'!
screenForm
	| screenForm screenImage colorMap pickValue elseValue |
	passingColor ifNil: [passingColor := Color black].
	pickValue := 4294967295.
	elseValue := 0.
	screenImage := screen costume asFormOfDepth: Display depth.
	colorMap := screenImage newColorMap atAllPut: elseValue.
	colorMap
		at: (passingColor indexInMap: colorMap)
		put: pickValue.
	screenForm := Form extent: screenImage extent.
	screenForm
		copyBits: screenForm boundingBox
		from: screenImage
		at: 0 @ 0
		colorMap: colorMap.
	^ screenForm! !

!CScreeningCostume methodsFor: 'drawing' stamp: 'tak 5/9/2005 16:17'!
sourceForm
	| box aCanvas |
	box := self localBounds.
	aCanvas := CTransformCanvas extent: box extent depth: Display depth.
	aCanvas
		translateBy: box origin negated
		during: [:cc | costume drawOn: cc in: box].
	^ aCanvas form! !

CPlayer subclass: #CStickyPad
	instanceVariableNames: ''
	classVariableNames: 'Colors LastColorIndex'
	poolDictionaries: ''
	category: 'Tweak-EToys'!

!CStickyPad commentStamp: 'sw 5/1/2005 06:16' prior: 0!
A custom item for etoy users, as defined by Kim Rose and BJ Con.A parts bin will deliver up translucent, borderless Rectangles in a sequence of 6 colors.  It offers some complication to the parts-bin protocols in two ways::
* The multi-colored icon seen in the parts bin is not a thumbnail of any actual instance, all of which are monochrome
* New instances need to be given default names that are not the same as the name seen in the parts bin.!

CStickyPad defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CStickyPad class methodsFor: 'class initialization' stamp: 'sw 4/20/2005 18:07'!
initialize
	"Class initialization"

	LastColorIndex := 0.
	Colors :=  {
		TranslucentColor r: 0.0 g: 0.0 b: 0.839 alpha: 0.267.
		TranslucentColor r: 0.484 g: 1.0 b: 0.452 alpha: 0.706.
		TranslucentColor r: 1.0 g: 0.355 b: 0.71 alpha: 0.569.
		TranslucentColor r: 1.0 g: 1.0 b: 0.03 alpha: 0.561.
		TranslucentColor r: 0.484 g: 0.161 b: 1.0 alpha: 0.529.
		TranslucentColor r: 0.097 g: 0.097 b: 0.097 alpha: 0.192.
	}.
	self registerWithPartsBin.

"CStickyPad initialize"! !

!CStickyPad class methodsFor: 'class initialization' stamp: 'sw 5/1/2005 04:26'!
registerWithPartsBin
	"Register the receiver in the basic category"

	| aPartDescription |
	aPartDescription := CPartDescription partDescriptionWithLabel: 'StickyPad' balloonHelp: 'A translucent, borderless rectangle of a standard size, delivered in a predictable sequence of pastel colors' category: 'miscellaneous' creator: self selector: #newbornPartToDropIn: customForm: (Form extent: 100@80 depth: 16 fromArray: #( 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741) offset: 0@0).
				
	CPartsBin registerPartDescription: aPartDescription

"CStickyPad registerWithPartsBin"! !

!CStickyPad class methodsFor: 'class initialization' stamp: 'sw 6/12/2005 19:13'!
registerWithPartsSource: aPartsSource
	"Register the receiver in the basic category"

	| aPartDescription |
	aPartDescription := CPartDescription partDescriptionWithLabel: 'StickyPad' balloonHelp: 'A translucent, borderless rectangle of a standard size, delivered in a predictable sequence of pastel colors' category: 'miscellaneous' creator: self selector: #newbornPartToDropIn: customForm: (Form extent: 100@80 depth: 16 fromArray: #( 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1322274512 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1521900214 1389318863 1389318863 1389318863 1389318863 1389318863 1389318863 1460426508 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1521900214 1723098804 1389318863 1389318863 1389318863 1389318863 1389318863 1328697138 1460426508 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1521900214 1723098804 1723098804 1389318863 1389318863 1389318863 1389318863 1328697138 1328697138 1460426508 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1521900214 1723098804 1723098804 1723098804 1389318863 1389318863 1389318863 1328697138 1328697138 1328697138 1460426508 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1521900214 1723098804 1723098804 1723098804 1723098804 1389318863 1389318863 1328697138 1328697138 1328697138 1328697138 1460426508 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1521900214 1723098804 1723098804 1723098804 1723098804 1723098804 1389318863 1328697138 1328697138 1328697138 1328697138 1328697138 1460426508 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1461409563 1723098804 1723098804 1723098804 1723098804 1723098804 1723098804 1328697138 1328697138 1328697138 1328697138 1328697138 1328697138 1659658988 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1461409563 1796762392 1723098804 1723098804 1723098804 1723098804 1723098804 1599692633 1328697138 1328697138 1328697138 1328697138 1328697138 1662149394 1659658988 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1461409563 1796762392 1796762392 1723098804 1723098804 1723098804 1723098804 1599692633 1599692633 1328697138 1328697138 1328697138 1328697138 1662149394 1662149394 1659658988 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1461409563 1796762392 1796762392 1796762392 1723098804 1723098804 1723098804 1599692633 1599692633 1599692633 1328697138 1328697138 1328697138 1662149394 1662149394 1662149394 1659658988 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1461409563 1796762392 1796762392 1796762392 1796762392 1723098804 1723098804 1599692633 1599692633 1599692633 1599692633 1328697138 1328697138 1662149394 1662149394 1662149394 1662149394 1659658988 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1461409563 1796762392 1796762392 1796762392 1796762392 1796762392 1723098804 1599692633 1599692633 1599692633 1599692633 1599692633 1328697138 1662149394 1662149394 1662149394 1662149394 1662149394 1659658988 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741 1736271741) offset: 0@0).
				
	aPartsSource registerPartDescription: aPartDescription! !

!CStickyPad methodsFor: 'initialization' stamp: 'sw 4/26/2005 03:38'!
initialize
	"Initialize the receiver.  Use the next color in the standard sequence."

	super initialize.
	Colors ifNil: [self class initialize].
	LastColorIndex := 
		LastColorIndex
			ifNil:
				[1]
			ifNotNil:
				[(LastColorIndex \\ Colors size) + 1].
	color := Colors at: LastColorIndex.
	extent := 100@80.
	borderWidth := 0.
	name := 'tear off' translated.
	self propertyValueAt: #useCustomForm put: true
	! !

CPlayer subclass: #EToysIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys-Experimental'!

!EToysIcon commentStamp: '<historical>' prior: 0!
I represent a labeled icon for some target!

EToysIcon defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="icon" toSet="icon:" changeEvent="iconChanged">icon</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
</fields>'!

!EToysIcon methodsFor: 'selecting' stamp: 'ar 6/20/2005 16:03'!
deselect
	"Select the receiver"
	color := Color transparent.! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
icon
	"Answer the icon of the receiver"
	<bewareOf: #iconChanged>
	^self propertyValueAt: #icon! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
icon: aValue
	"Modify the receiver's icon"
	^self propertyValueAt: #icon put: aValue with: #iconChanged! !

!EToysIcon methodsFor: 'initialize' stamp: 'ar 6/20/2005 15:45'!
initialize
	super initialize.
	icon := CPlayer new.
	label := CLabel new.! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!EToysIcon methodsFor: 'private' stamp: 'ar 6/20/2005 15:58'!
listItemValue: aPlayer
	target := aPlayer.! !

!EToysIcon methodsFor: 'events' stamp: 'ar 6/20/2005 15:57'!
onNameChanged
	<on: nameChanged in: target>
	label value: (target name truncateTo: 20).
	self balloonHelp := target name.! !

!EToysIcon methodsFor: 'events' stamp: 'ar 6/20/2005 18:08'!
onTargetChanged
	| form |
	<on: targetChanged>
	target ifNil:[^self].
	form := target makeIcon: 64@64.
	icon graphicForm := form.
	icon extent := 64@64.
	self onNameChanged.
! !

!EToysIcon methodsFor: 'selecting' stamp: 'ar 6/20/2005 16:03'!
select
	"Select the receiver"
	color := CWidgetLibrary default baseColor.! !

!EToysIcon methodsFor: 'initialize' stamp: 'ar 6/20/2005 16:01'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	layout layoutInset := 4.

	self borderStyle := #simple.
	self borderWidth := 1.
	self borderColor := CWidgetLibrary default baseColor.
	self roundCorners := true.

	icon graphicEnabled := true.
	icon graphicFit := #rigid.
	self addLast: icon.
	label hResizing: #shrinkWrap.
	self addLast: label.
! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!EToysIcon methodsFor: 'accessing' stamp: 'ar 6/20/2005 15:44'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #EToysPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys-Experimental'!

EToysPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="eToyCostumes" toSet="eToyCostumes:" changeEvent="eToyCostumesChanged">eToyCostumes</field>
</fields>'!

!EToysPlayer methodsFor: 'accessing' stamp: 'ar 6/20/2005 21:41'!
eToyCostumes
	"Answer the eToyCostumes of the receiver"
	<bewareOf: #eToyCostumesChanged>
	^self propertyValueAt: #eToyCostumes! !

!EToysPlayer methodsFor: 'accessing' stamp: 'ar 6/20/2005 21:41'!
eToyCostumes: aValue
	"Modify the receiver's eToyCostumes"
	^self propertyValueAt: #eToyCostumes put: aValue with: #eToyCostumesChanged! !

!EToysPlayer methodsFor: 'initialize' stamp: 'ar 6/20/2005 21:44'!
initialize
	super initialize.
	self define: #eToyCostumes as: CCollection new.
	eToyCostumes wrapCursor: true.! !

!EToysPlayer methodsFor: 'events' stamp: 'ar 6/20/2005 21:42'!
onCostumeChanged
	<on: costumeChanged>
	eToyCostumes selection: costume.! !

!EToysPlayer methodsFor: 'events' stamp: 'ar 6/20/2005 21:42'!
onCostumesCursorChanged
	<on: cursorChanged in: eToyCostumes>
	costume := eToyCostumes selection ifNil:[self defaultCostume].! !

!EToysPlayer methodsFor: 'events' stamp: 'ar 6/20/2005 16:36'!
onMouseDoubleClick
	| tool evt |
	<on: mouseDoubleClick>
	self world signal: #costumesToolRequest with: self.
	evt := self catchAnyOf: {self. #costumesToolFound} during:[self waitTick].
	evt ifNotNil:[^self].
	tool := EToysCostumesTool new.
	tool target: self.
	tool openAt: self worldBounds rightCenter.! !

!EToysPlayer methodsFor: 'events' stamp: 'ar 6/20/2005 16:24'!
onMouseDrag
	<on: mouseDrag>
	self onDrag.! !

CPlayer subclass: #EToysWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

EToysWorld defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!EToysWorld methodsFor: 'initialize' stamp: 'ar 12/14/2009 19:17'!
setupCostume
	super setupCostume.
	self color := Color r:0.937 g: 0.937 b: 0.937.
! !

CProject2 subclass: #EToysProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

EToysProject defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="halo" toSet="halo:" changeEvent="haloChanged">halo</field>
	<field toGet="haloTarget" toSet="haloTarget:" changeEvent="haloTargetChanged">haloTarget</field>
	<field toGet="trashManager" toSet="trashManager:" changeEvent="trashManagerChanged">trashManager</field>
	<field toGet="scriptManager" toSet="scriptManager:" changeEvent="scriptManagerChanged">scriptManager</field>
</fields>'!

!EToysProject class methodsFor: 'class initialization' stamp: 'ar 12/12/2009 20:50'!
initialize
	"EToysProject initialize"
	CProject2 defaultProject: self.
! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/28/2005 19:50'!
halo
	"Answer the halo of the receiver"
	<bewareOf: #haloChanged>
	^self propertyValueAt: #halo! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/28/2005 19:50'!
halo: aValue
	"Modify the receiver's halo"
	^self propertyValueAt: #halo put: aValue with: #haloChanged! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 6/25/2005 18:55'!
haloTarget
	"Answer the haloTarget of the receiver"
	<bewareOf: #haloTargetChanged>
	^self propertyValueAt: #haloTarget! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 6/25/2005 18:55'!
haloTarget: aValue
	"Modify the receiver's haloTarget"
	^self propertyValueAt: #haloTarget put: aValue with: #haloTargetChanged! !

!EToysProject methodsFor: 'initialize' stamp: 'ar 5/29/2005 19:30'!
initialize
	super initialize.
	halo := CHalo new.
	halo userDraw: true.
	halo visible: false.
	trashManager := CTrashManager new.
	trashManager project: self.
	scriptManager := EToyScriptManager new.
	scriptManager project: self.! !

!EToysProject methodsFor: 'scripting' stamp: 'bf 7/12/2005 18:39'!
lookupScope
	^scriptManager! !

!EToysProject methodsFor: 'initialize' stamp: 'ar 5/28/2005 19:54'!
newProject
	^self newProjectWith: EToysWorld new.! !

!EToysProject methodsFor: 'initialize' stamp: 'ar 6/3/2005 13:48'!
newProjectWith: aWorld
	super newProjectWith: aWorld.
	world add: halo.
	world indicatePenTrails: true.! !

!EToysProject methodsFor: 'events' stamp: 'ar 5/28/2005 19:55'!
onBlueButtonDown
	<on: blueButtonDown in: world>
	self halo onBlueButtonDown! !

!EToysProject methodsFor: 'events' stamp: 'ar 6/25/2005 16:21'!
onDrop: aPlayer
	"If the project doesn't handle drops, handle them for it"
	<on: dragDrop in: world>
	aPlayer container == world ifFalse:[
		"Do not change z-order unless necessary"
		world add: aPlayer.
	].
	"And inform it about the drop"
	aPlayer signal: #dropAccept with: world.! !

!EToysProject methodsFor: 'events' stamp: 'ar 5/28/2005 19:58'!
onMouseDown
	| dragChild |
	<on: mouseDown in: world>
	dragChild := world findDraggablePlayerAt: world cursorPoint.
	dragChild ifNotNil:[^dragChild onDrag].
	"clicks on desktop remove halo and keyboard focus"
	world hand keyboardFocus ifNotNil:[world hand keyboardFocus: nil].
	self halo target ifNotNil:[self halo target: nil].! !

!EToysProject methodsFor: 'events' stamp: 'ar 5/27/2007 16:58'!
onShutDownProject: quitting
	super onShutDownProject: quitting.
	halo ifNotNil:[
		haloTarget := halo target.
		halo close.
	].
	halo := nil.
! !

!EToysProject methodsFor: 'events' stamp: 'ar 6/26/2005 15:15'!
onStartUpProject: resuming
	"Start up this project"
	super onStartUpProject: resuming.
	halo ifNil:[
		halo := CHalo new.
		halo userDraw: true.
		halo visible: false.
		world ifNotNil:[world add: halo].
		halo target: haloTarget.
		haloTarget := nil.
	].! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:29'!
scriptManager
	"Answer the scriptManager of the receiver"
	<bewareOf: #scriptManagerChanged>
	^self propertyValueAt: #scriptManager! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:29'!
scriptManager: aValue
	"Modify the receiver's scriptManager"
	^self propertyValueAt: #scriptManager put: aValue with: #scriptManagerChanged! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:24'!
trashManager
	"Answer the trashManager of the receiver"
	<bewareOf: #trashManagerChanged>
	^self propertyValueAt: #trashManager! !

!EToysProject methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:24'!
trashManager: aValue
	"Modify the receiver's trashManager"
	^self propertyValueAt: #trashManager put: aValue with: #trashManagerChanged! !

TestCase subclass: #CMagnifierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

!CMagnifierTest methodsFor: 'testing' stamp: 'tak 5/9/2005 16:25'!
testNewRound
	"self debug: #testNewRound"
	| mag |
	mag := CMagnifier newRound.
	self assert: mag costume screen class == CEllipsePlayer.! !

!CMagnifierTest methodsFor: 'testing' stamp: 'tak 5/6/2005 15:02'!
testScreen
	"self debug: #testScreen"
	| c screen |
	c := CScreeningCostume new.
	c screen: (screen := CEllipsePlayer new color: Color red; yourself).
	self assert: c passingColor = Color red.
! !

!CMagnifierTest methodsFor: 'testing' stamp: 'ar 4/15/2007 19:33'!
testSourceRect
	"self debug: #testSourceRect"
	| p |
	p := CMagnifier new.
	p scale: 1.
	p extent: 10 @ 10.
	p borderWidth: 2.
	self assert: (p sourceRectFrom: 0@0) = (-3@-3 extent: 6@6).
false ifTrue:[
	p scale: 2.
	p extent: 10 @ 10.
	p borderWidth: 2. "actually 4"
	self assert: (p sourceRectFrom: 0@0) = (-1@-1 extent: 1@1).
].! !

CObject subclass: #EToyScriptManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-EToys'!

EToyScriptManager defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="project" toSet="project:" changeEvent="projectChanged">project</field>
	<field toGet="tickingStatus" toSet="tickingStatus:" changeEvent="tickingStatusChanged">tickingStatus</field>
	<field toGet="registeredUniClasses" toSet="registeredUniClasses:" changeEvent="registeredUniClassesChanged">registeredUniClasses</field>
	<field toGet="registeredObjects" toSet="registeredObjects:" changeEvent="registeredObjectsChanged">registeredObjects</field>
</fields>'!

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 6/23/2005 15:49'!
allScriptorsPausedOrTicking
	"Answer a list of all scriptors which are paused or ticking"

	^ Array streamContents:
		[:aStream |
			self registeredUniClassesDo:
				[:aUniClass |
					aUniClass allInstancesDo:
						[:aScriptedPlayer |
							"(aScriptedPlayer isActiveInProject: self)
								ifTrue: [...]"
							aScriptedPlayer scriptors do:
								[:scr | (scr ticking isKindOf: Boolean)
									ifTrue:
										[aStream nextPut: scr]]]]]! !

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 6/23/2005 15:49'!
allUniClassInstances
	"Answer a list of all uniClass instances known to the project"

	^ Array streamContents:
		[:aStream |
			self registeredUniClassesDo:
				[:aUniClass |
					aUniClass allInstancesDo:
						[:aScriptedPlayer |
							"(aScriptedPlayer isActiveInProject: self)
								ifTrue: [...]"
							aStream nextPut: aScriptedPlayer]]]
				! !

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 6/23/2005 15:47'!
deregisterUniClass: aUniClass
	"Remove the uniClass from my registry of known uniClasses.  OK to send this either the class object or an instance of it."

	| toDeregister classList |
	toDeregister := aUniClass class theNonMetaClass. 
	classList := self registeredUniClasses copyWithout: toDeregister.
	classList := classList copyWithout: nil.
	self registeredUniClasses: classList.! !

!EToyScriptManager methodsFor: 'initialize' stamp: 'bf 7/12/2005 19:15'!
initialize
	super initialize.
	tickingStatus := #ticking.
	registeredUniClasses := WeakArray new.
	registeredObjects := WeakValueDictionary new. "also initialized lazily"! !

!EToyScriptManager methodsFor: 'lookup' stamp: 'bf 7/12/2005 19:06'!
lookup: aLookupSpec
	"Lookup object from aLookupSpec. See lookupSpecFor:"

	^registeredObjects at: aLookupSpec
! !

!EToyScriptManager methodsFor: 'lookup' stamp: 'bf 7/12/2005 18:41'!
lookupScope
	^self! !

!EToyScriptManager methodsFor: 'lookup' stamp: 'bf 7/31/2005 17:03'!
lookupSpecFor: anObject
	"Answer a literal that can later be used to lookup anObject. See lookup:"
	| spec |
	anObject isBehavior ifTrue: [^anObject name "see lookupBehavior:"].
	anObject isPlayer ifFalse: [^self error: 'non-player references not supported yet'].
	spec := anObject userDataAt: #lookupSpec.
	spec ifNil: [
		spec := UUID new asString36.
		anObject userDataAt: #lookupSpec put: spec.
		registeredObjects at: spec put: anObject.
	].
	^spec
! !

!EToyScriptManager methodsFor: 'ticking status' stamp: 'ar 5/29/2005 19:26'!
newTickingStatus: aSymbol
	"Set the receiver's tickingStatus"
	tickingStatus := aSymbol.
	self allScriptorsPausedOrTicking do:
		[:scr |
			scr ticking == true
				ifTrue:
					[aSymbol == #paused ifTrue:
						[scr pause]].
			scr ticking == false
				ifTrue:
					[aSymbol == #ticking ifTrue:
						[scr start]]]! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:30'!
project
	"Answer the project of the receiver"
	<bewareOf: #projectChanged>
	^self propertyValueAt: #project! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:30'!
project: aValue
	"Modify the receiver's project"
	^self propertyValueAt: #project put: aValue with: #projectChanged! !

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 6/23/2005 15:47'!
registerUniClass: aUniClass
	"Register the argument as a known uniClass in the project."

	| classList toRegister |
	toRegister := aUniClass class theNonMetaClass. 
	classList := self registeredUniClasses copyWithout: toRegister.
	classList := classList copyWithout: nil.
	classList := classList copyWith: toRegister.
	self registeredUniClasses: classList.! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'bf 7/12/2005 19:15'!
registeredObjects
	"Answer the registeredObjects of the receiver"
	<bewareOf: #registeredObjectsChanged>
	self flag: #bf. "remove initialization here"
	^self propertyValueAt: #registeredObjects ifAbsentPut: [WeakValueDictionary new].! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'bf 7/12/2005 18:42'!
registeredObjects: aValue
	"Modify the receiver's registeredObjects"
	^self propertyValueAt: #registeredObjects put: aValue with: #registeredObjectsChanged! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:27'!
registeredUniClasses
	"Answer the registeredUniClasses of the receiver"
	<bewareOf: #registeredUniClassesChanged>
	^self propertyValueAt: #registeredUniClasses! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:27'!
registeredUniClasses: aValue
	"Modify the receiver's registeredUniClasses"
	^self propertyValueAt: #registeredUniClasses put: aValue with: #registeredUniClassesChanged! !

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 6/23/2005 15:49'!
registeredUniClassesDo: aBlock
	"Answer a list of all uniClass instances known to the project"
	| classList aClass |
	classList := self registeredUniClasses.
	1 to: classList size do:[:i| 
		(aClass := classList at: i) ifNotNil:[aBlock value: aClass].
	].! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:25'!
tickingStatus
	"Answer the tickingStatus of the receiver"
	<bewareOf: #tickingStatusChanged>
	^self propertyValueAt: #tickingStatus! !

!EToyScriptManager methodsFor: 'accessing' stamp: 'ar 5/29/2005 19:25'!
tickingStatus: aValue
	"Modify the receiver's tickingStatus"
	^self propertyValueAt: #tickingStatus put: aValue with: #tickingStatusChanged! !

!EToyScriptManager methodsFor: 'uniclasses' stamp: 'ar 5/29/2005 19:26'!
uniClassCreatedFor: aPlayer
	"A uniclass has been created for the given player.  For now, we'll automatically register all such..."
	self registerUniClass: aPlayer! !
CMagnifier initialize!
CStickyPad initialize!
EToysProject initialize!
